# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetMongodbflexInstanceResult',
    'AwaitableGetMongodbflexInstanceResult',
    'get_mongodbflex_instance',
    'get_mongodbflex_instance_output',
]

@pulumi.output_type
class GetMongodbflexInstanceResult:
    """
    A collection of values returned by getMongodbflexInstance.
    """
    def __init__(__self__, acls=None, backup_schedule=None, flavor=None, id=None, instance_id=None, name=None, options=None, project_id=None, replicas=None, storage=None, version=None):
        if acls and not isinstance(acls, list):
            raise TypeError("Expected argument 'acls' to be a list")
        pulumi.set(__self__, "acls", acls)
        if backup_schedule and not isinstance(backup_schedule, str):
            raise TypeError("Expected argument 'backup_schedule' to be a str")
        pulumi.set(__self__, "backup_schedule", backup_schedule)
        if flavor and not isinstance(flavor, dict):
            raise TypeError("Expected argument 'flavor' to be a dict")
        pulumi.set(__self__, "flavor", flavor)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if options and not isinstance(options, dict):
            raise TypeError("Expected argument 'options' to be a dict")
        pulumi.set(__self__, "options", options)
        if project_id and not isinstance(project_id, str):
            raise TypeError("Expected argument 'project_id' to be a str")
        pulumi.set(__self__, "project_id", project_id)
        if replicas and not isinstance(replicas, int):
            raise TypeError("Expected argument 'replicas' to be a int")
        pulumi.set(__self__, "replicas", replicas)
        if storage and not isinstance(storage, dict):
            raise TypeError("Expected argument 'storage' to be a dict")
        pulumi.set(__self__, "storage", storage)
        if version and not isinstance(version, str):
            raise TypeError("Expected argument 'version' to be a str")
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def acls(self) -> Sequence[builtins.str]:
        """
        The Access Control List (ACL) for the MongoDB Flex instance.
        """
        return pulumi.get(self, "acls")

    @property
    @pulumi.getter(name="backupSchedule")
    def backup_schedule(self) -> builtins.str:
        """
        The backup schedule. Should follow the cron scheduling system format (e.g. "0 0 * * *").
        """
        return pulumi.get(self, "backup_schedule")

    @property
    @pulumi.getter
    def flavor(self) -> 'outputs.GetMongodbflexInstanceFlavorResult':
        return pulumi.get(self, "flavor")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> builtins.str:
        """
        ID of the MongoDB Flex instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        Instance name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def options(self) -> 'outputs.GetMongodbflexInstanceOptionsResult':
        """
        Custom parameters for the MongoDB Flex instance.
        """
        return pulumi.get(self, "options")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> builtins.str:
        """
        STACKIT project ID to which the instance is associated.
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter
    def replicas(self) -> builtins.int:
        return pulumi.get(self, "replicas")

    @property
    @pulumi.getter
    def storage(self) -> 'outputs.GetMongodbflexInstanceStorageResult':
        return pulumi.get(self, "storage")

    @property
    @pulumi.getter
    def version(self) -> builtins.str:
        return pulumi.get(self, "version")


class AwaitableGetMongodbflexInstanceResult(GetMongodbflexInstanceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetMongodbflexInstanceResult(
            acls=self.acls,
            backup_schedule=self.backup_schedule,
            flavor=self.flavor,
            id=self.id,
            instance_id=self.instance_id,
            name=self.name,
            options=self.options,
            project_id=self.project_id,
            replicas=self.replicas,
            storage=self.storage,
            version=self.version)


def get_mongodbflex_instance(instance_id: Optional[builtins.str] = None,
                             project_id: Optional[builtins.str] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetMongodbflexInstanceResult:
    """
    MongoDB Flex instance data source schema. Must have a `region` specified in the provider configuration.

    ## Example Usage


    :param builtins.str instance_id: ID of the MongoDB Flex instance.
    :param builtins.str project_id: STACKIT project ID to which the instance is associated.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['projectId'] = project_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('stackit:index/getMongodbflexInstance:getMongodbflexInstance', __args__, opts=opts, typ=GetMongodbflexInstanceResult).value

    return AwaitableGetMongodbflexInstanceResult(
        acls=pulumi.get(__ret__, 'acls'),
        backup_schedule=pulumi.get(__ret__, 'backup_schedule'),
        flavor=pulumi.get(__ret__, 'flavor'),
        id=pulumi.get(__ret__, 'id'),
        instance_id=pulumi.get(__ret__, 'instance_id'),
        name=pulumi.get(__ret__, 'name'),
        options=pulumi.get(__ret__, 'options'),
        project_id=pulumi.get(__ret__, 'project_id'),
        replicas=pulumi.get(__ret__, 'replicas'),
        storage=pulumi.get(__ret__, 'storage'),
        version=pulumi.get(__ret__, 'version'))
def get_mongodbflex_instance_output(instance_id: Optional[pulumi.Input[builtins.str]] = None,
                                    project_id: Optional[pulumi.Input[builtins.str]] = None,
                                    opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetMongodbflexInstanceResult]:
    """
    MongoDB Flex instance data source schema. Must have a `region` specified in the provider configuration.

    ## Example Usage


    :param builtins.str instance_id: ID of the MongoDB Flex instance.
    :param builtins.str project_id: STACKIT project ID to which the instance is associated.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['projectId'] = project_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('stackit:index/getMongodbflexInstance:getMongodbflexInstance', __args__, opts=opts, typ=GetMongodbflexInstanceResult)
    return __ret__.apply(lambda __response__: GetMongodbflexInstanceResult(
        acls=pulumi.get(__response__, 'acls'),
        backup_schedule=pulumi.get(__response__, 'backup_schedule'),
        flavor=pulumi.get(__response__, 'flavor'),
        id=pulumi.get(__response__, 'id'),
        instance_id=pulumi.get(__response__, 'instance_id'),
        name=pulumi.get(__response__, 'name'),
        options=pulumi.get(__response__, 'options'),
        project_id=pulumi.get(__response__, 'project_id'),
        replicas=pulumi.get(__response__, 'replicas'),
        storage=pulumi.get(__response__, 'storage'),
        version=pulumi.get(__response__, 'version')))
