# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetObjectstorageCredentialResult',
    'AwaitableGetObjectstorageCredentialResult',
    'get_objectstorage_credential',
    'get_objectstorage_credential_output',
]

@pulumi.output_type
class GetObjectstorageCredentialResult:
    """
    A collection of values returned by getObjectstorageCredential.
    """
    def __init__(__self__, credential_id=None, credentials_group_id=None, expiration_timestamp=None, id=None, name=None, project_id=None, region=None):
        if credential_id and not isinstance(credential_id, str):
            raise TypeError("Expected argument 'credential_id' to be a str")
        pulumi.set(__self__, "credential_id", credential_id)
        if credentials_group_id and not isinstance(credentials_group_id, str):
            raise TypeError("Expected argument 'credentials_group_id' to be a str")
        pulumi.set(__self__, "credentials_group_id", credentials_group_id)
        if expiration_timestamp and not isinstance(expiration_timestamp, str):
            raise TypeError("Expected argument 'expiration_timestamp' to be a str")
        pulumi.set(__self__, "expiration_timestamp", expiration_timestamp)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if project_id and not isinstance(project_id, str):
            raise TypeError("Expected argument 'project_id' to be a str")
        pulumi.set(__self__, "project_id", project_id)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="credentialId")
    def credential_id(self) -> builtins.str:
        """
        The credential ID.
        """
        return pulumi.get(self, "credential_id")

    @property
    @pulumi.getter(name="credentialsGroupId")
    def credentials_group_id(self) -> builtins.str:
        """
        The credential group ID.
        """
        return pulumi.get(self, "credentials_group_id")

    @property
    @pulumi.getter(name="expirationTimestamp")
    def expiration_timestamp(self) -> builtins.str:
        return pulumi.get(self, "expiration_timestamp")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> builtins.str:
        """
        STACKIT Project ID to which the credential group is associated.
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter
    def region(self) -> Optional[builtins.str]:
        """
        The resource region. If not defined, the provider region is used.
        """
        return pulumi.get(self, "region")


class AwaitableGetObjectstorageCredentialResult(GetObjectstorageCredentialResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetObjectstorageCredentialResult(
            credential_id=self.credential_id,
            credentials_group_id=self.credentials_group_id,
            expiration_timestamp=self.expiration_timestamp,
            id=self.id,
            name=self.name,
            project_id=self.project_id,
            region=self.region)


def get_objectstorage_credential(credential_id: Optional[builtins.str] = None,
                                 credentials_group_id: Optional[builtins.str] = None,
                                 project_id: Optional[builtins.str] = None,
                                 region: Optional[builtins.str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetObjectstorageCredentialResult:
    """
    ObjectStorage credential data source schema. Must have a `region` specified in the provider configuration.

    ## Example Usage


    :param builtins.str credential_id: The credential ID.
    :param builtins.str credentials_group_id: The credential group ID.
    :param builtins.str project_id: STACKIT Project ID to which the credential group is associated.
    :param builtins.str region: The resource region. If not defined, the provider region is used.
    """
    __args__ = dict()
    __args__['credentialId'] = credential_id
    __args__['credentialsGroupId'] = credentials_group_id
    __args__['projectId'] = project_id
    __args__['region'] = region
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('stackit:index/getObjectstorageCredential:getObjectstorageCredential', __args__, opts=opts, typ=GetObjectstorageCredentialResult).value

    return AwaitableGetObjectstorageCredentialResult(
        credential_id=pulumi.get(__ret__, 'credential_id'),
        credentials_group_id=pulumi.get(__ret__, 'credentials_group_id'),
        expiration_timestamp=pulumi.get(__ret__, 'expiration_timestamp'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        project_id=pulumi.get(__ret__, 'project_id'),
        region=pulumi.get(__ret__, 'region'))
def get_objectstorage_credential_output(credential_id: Optional[pulumi.Input[builtins.str]] = None,
                                        credentials_group_id: Optional[pulumi.Input[builtins.str]] = None,
                                        project_id: Optional[pulumi.Input[builtins.str]] = None,
                                        region: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetObjectstorageCredentialResult]:
    """
    ObjectStorage credential data source schema. Must have a `region` specified in the provider configuration.

    ## Example Usage


    :param builtins.str credential_id: The credential ID.
    :param builtins.str credentials_group_id: The credential group ID.
    :param builtins.str project_id: STACKIT Project ID to which the credential group is associated.
    :param builtins.str region: The resource region. If not defined, the provider region is used.
    """
    __args__ = dict()
    __args__['credentialId'] = credential_id
    __args__['credentialsGroupId'] = credentials_group_id
    __args__['projectId'] = project_id
    __args__['region'] = region
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('stackit:index/getObjectstorageCredential:getObjectstorageCredential', __args__, opts=opts, typ=GetObjectstorageCredentialResult)
    return __ret__.apply(lambda __response__: GetObjectstorageCredentialResult(
        credential_id=pulumi.get(__response__, 'credential_id'),
        credentials_group_id=pulumi.get(__response__, 'credentials_group_id'),
        expiration_timestamp=pulumi.get(__response__, 'expiration_timestamp'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        project_id=pulumi.get(__response__, 'project_id'),
        region=pulumi.get(__response__, 'region')))
