# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetObjectstorageCredentialsGroupResult',
    'AwaitableGetObjectstorageCredentialsGroupResult',
    'get_objectstorage_credentials_group',
    'get_objectstorage_credentials_group_output',
]

@pulumi.output_type
class GetObjectstorageCredentialsGroupResult:
    """
    A collection of values returned by getObjectstorageCredentialsGroup.
    """
    def __init__(__self__, credentials_group_id=None, id=None, name=None, project_id=None, region=None, urn=None):
        if credentials_group_id and not isinstance(credentials_group_id, str):
            raise TypeError("Expected argument 'credentials_group_id' to be a str")
        pulumi.set(__self__, "credentials_group_id", credentials_group_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if project_id and not isinstance(project_id, str):
            raise TypeError("Expected argument 'project_id' to be a str")
        pulumi.set(__self__, "project_id", project_id)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if urn and not isinstance(urn, str):
            raise TypeError("Expected argument 'urn' to be a str")
        pulumi.set(__self__, "urn", urn)

    @property
    @pulumi.getter(name="credentialsGroupId")
    def credentials_group_id(self) -> builtins.str:
        """
        The credentials group ID.
        """
        return pulumi.get(self, "credentials_group_id")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The credentials group's display name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> builtins.str:
        """
        Object Storage Project ID to which the credentials group is associated.
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter
    def region(self) -> Optional[builtins.str]:
        """
        The resource region. If not defined, the provider region is used.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def urn(self) -> builtins.str:
        """
        Credentials group uniform resource name (URN)
        """
        return pulumi.get(self, "urn")


class AwaitableGetObjectstorageCredentialsGroupResult(GetObjectstorageCredentialsGroupResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetObjectstorageCredentialsGroupResult(
            credentials_group_id=self.credentials_group_id,
            id=self.id,
            name=self.name,
            project_id=self.project_id,
            region=self.region,
            urn=self.urn)


def get_objectstorage_credentials_group(credentials_group_id: Optional[builtins.str] = None,
                                        project_id: Optional[builtins.str] = None,
                                        region: Optional[builtins.str] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetObjectstorageCredentialsGroupResult:
    """
    ObjectStorage credentials group data source schema. Must have a `region` specified in the provider configuration.

    ## Example Usage


    :param builtins.str credentials_group_id: The credentials group ID.
    :param builtins.str project_id: Object Storage Project ID to which the credentials group is associated.
    :param builtins.str region: The resource region. If not defined, the provider region is used.
    """
    __args__ = dict()
    __args__['credentialsGroupId'] = credentials_group_id
    __args__['projectId'] = project_id
    __args__['region'] = region
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('stackit:index/getObjectstorageCredentialsGroup:getObjectstorageCredentialsGroup', __args__, opts=opts, typ=GetObjectstorageCredentialsGroupResult).value

    return AwaitableGetObjectstorageCredentialsGroupResult(
        credentials_group_id=pulumi.get(__ret__, 'credentials_group_id'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        project_id=pulumi.get(__ret__, 'project_id'),
        region=pulumi.get(__ret__, 'region'),
        urn=pulumi.get(__ret__, 'urn'))
def get_objectstorage_credentials_group_output(credentials_group_id: Optional[pulumi.Input[builtins.str]] = None,
                                               project_id: Optional[pulumi.Input[builtins.str]] = None,
                                               region: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetObjectstorageCredentialsGroupResult]:
    """
    ObjectStorage credentials group data source schema. Must have a `region` specified in the provider configuration.

    ## Example Usage


    :param builtins.str credentials_group_id: The credentials group ID.
    :param builtins.str project_id: Object Storage Project ID to which the credentials group is associated.
    :param builtins.str region: The resource region. If not defined, the provider region is used.
    """
    __args__ = dict()
    __args__['credentialsGroupId'] = credentials_group_id
    __args__['projectId'] = project_id
    __args__['region'] = region
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('stackit:index/getObjectstorageCredentialsGroup:getObjectstorageCredentialsGroup', __args__, opts=opts, typ=GetObjectstorageCredentialsGroupResult)
    return __ret__.apply(lambda __response__: GetObjectstorageCredentialsGroupResult(
        credentials_group_id=pulumi.get(__response__, 'credentials_group_id'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        project_id=pulumi.get(__response__, 'project_id'),
        region=pulumi.get(__response__, 'region'),
        urn=pulumi.get(__response__, 'urn')))
