# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['MongodbflexInstanceArgs', 'MongodbflexInstance']

@pulumi.input_type
class MongodbflexInstanceArgs:
    def __init__(__self__, *,
                 acls: pulumi.Input[Sequence[pulumi.Input[builtins.str]]],
                 backup_schedule: pulumi.Input[builtins.str],
                 flavor: pulumi.Input['MongodbflexInstanceFlavorArgs'],
                 options: pulumi.Input['MongodbflexInstanceOptionsArgs'],
                 project_id: pulumi.Input[builtins.str],
                 replicas: pulumi.Input[builtins.int],
                 storage: pulumi.Input['MongodbflexInstanceStorageArgs'],
                 version: pulumi.Input[builtins.str],
                 name: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a MongodbflexInstance resource.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] acls: The Access Control List (ACL) for the MongoDB Flex instance.
        :param pulumi.Input[builtins.str] backup_schedule: The backup schedule. Should follow the cron scheduling system format (e.g. "0 0 * * *").
        :param pulumi.Input[builtins.str] project_id: STACKIT project ID to which the instance is associated.
        :param pulumi.Input[builtins.str] name: Instance name.
        """
        pulumi.set(__self__, "acls", acls)
        pulumi.set(__self__, "backup_schedule", backup_schedule)
        pulumi.set(__self__, "flavor", flavor)
        pulumi.set(__self__, "options", options)
        pulumi.set(__self__, "project_id", project_id)
        pulumi.set(__self__, "replicas", replicas)
        pulumi.set(__self__, "storage", storage)
        pulumi.set(__self__, "version", version)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def acls(self) -> pulumi.Input[Sequence[pulumi.Input[builtins.str]]]:
        """
        The Access Control List (ACL) for the MongoDB Flex instance.
        """
        return pulumi.get(self, "acls")

    @acls.setter
    def acls(self, value: pulumi.Input[Sequence[pulumi.Input[builtins.str]]]):
        pulumi.set(self, "acls", value)

    @property
    @pulumi.getter(name="backupSchedule")
    def backup_schedule(self) -> pulumi.Input[builtins.str]:
        """
        The backup schedule. Should follow the cron scheduling system format (e.g. "0 0 * * *").
        """
        return pulumi.get(self, "backup_schedule")

    @backup_schedule.setter
    def backup_schedule(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "backup_schedule", value)

    @property
    @pulumi.getter
    def flavor(self) -> pulumi.Input['MongodbflexInstanceFlavorArgs']:
        return pulumi.get(self, "flavor")

    @flavor.setter
    def flavor(self, value: pulumi.Input['MongodbflexInstanceFlavorArgs']):
        pulumi.set(self, "flavor", value)

    @property
    @pulumi.getter
    def options(self) -> pulumi.Input['MongodbflexInstanceOptionsArgs']:
        return pulumi.get(self, "options")

    @options.setter
    def options(self, value: pulumi.Input['MongodbflexInstanceOptionsArgs']):
        pulumi.set(self, "options", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Input[builtins.str]:
        """
        STACKIT project ID to which the instance is associated.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter
    def replicas(self) -> pulumi.Input[builtins.int]:
        return pulumi.get(self, "replicas")

    @replicas.setter
    def replicas(self, value: pulumi.Input[builtins.int]):
        pulumi.set(self, "replicas", value)

    @property
    @pulumi.getter
    def storage(self) -> pulumi.Input['MongodbflexInstanceStorageArgs']:
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: pulumi.Input['MongodbflexInstanceStorageArgs']):
        pulumi.set(self, "storage", value)

    @property
    @pulumi.getter
    def version(self) -> pulumi.Input[builtins.str]:
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "version", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Instance name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _MongodbflexInstanceState:
    def __init__(__self__, *,
                 acls: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 backup_schedule: Optional[pulumi.Input[builtins.str]] = None,
                 flavor: Optional[pulumi.Input['MongodbflexInstanceFlavorArgs']] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 options: Optional[pulumi.Input['MongodbflexInstanceOptionsArgs']] = None,
                 project_id: Optional[pulumi.Input[builtins.str]] = None,
                 replicas: Optional[pulumi.Input[builtins.int]] = None,
                 storage: Optional[pulumi.Input['MongodbflexInstanceStorageArgs']] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering MongodbflexInstance resources.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] acls: The Access Control List (ACL) for the MongoDB Flex instance.
        :param pulumi.Input[builtins.str] backup_schedule: The backup schedule. Should follow the cron scheduling system format (e.g. "0 0 * * *").
        :param pulumi.Input[builtins.str] instance_id: ID of the MongoDB Flex instance.
        :param pulumi.Input[builtins.str] name: Instance name.
        :param pulumi.Input[builtins.str] project_id: STACKIT project ID to which the instance is associated.
        """
        if acls is not None:
            pulumi.set(__self__, "acls", acls)
        if backup_schedule is not None:
            pulumi.set(__self__, "backup_schedule", backup_schedule)
        if flavor is not None:
            pulumi.set(__self__, "flavor", flavor)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if options is not None:
            pulumi.set(__self__, "options", options)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)
        if replicas is not None:
            pulumi.set(__self__, "replicas", replicas)
        if storage is not None:
            pulumi.set(__self__, "storage", storage)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def acls(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        The Access Control List (ACL) for the MongoDB Flex instance.
        """
        return pulumi.get(self, "acls")

    @acls.setter
    def acls(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "acls", value)

    @property
    @pulumi.getter(name="backupSchedule")
    def backup_schedule(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The backup schedule. Should follow the cron scheduling system format (e.g. "0 0 * * *").
        """
        return pulumi.get(self, "backup_schedule")

    @backup_schedule.setter
    def backup_schedule(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "backup_schedule", value)

    @property
    @pulumi.getter
    def flavor(self) -> Optional[pulumi.Input['MongodbflexInstanceFlavorArgs']]:
        return pulumi.get(self, "flavor")

    @flavor.setter
    def flavor(self, value: Optional[pulumi.Input['MongodbflexInstanceFlavorArgs']]):
        pulumi.set(self, "flavor", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        ID of the MongoDB Flex instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Instance name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def options(self) -> Optional[pulumi.Input['MongodbflexInstanceOptionsArgs']]:
        return pulumi.get(self, "options")

    @options.setter
    def options(self, value: Optional[pulumi.Input['MongodbflexInstanceOptionsArgs']]):
        pulumi.set(self, "options", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        STACKIT project ID to which the instance is associated.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter
    def replicas(self) -> Optional[pulumi.Input[builtins.int]]:
        return pulumi.get(self, "replicas")

    @replicas.setter
    def replicas(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "replicas", value)

    @property
    @pulumi.getter
    def storage(self) -> Optional[pulumi.Input['MongodbflexInstanceStorageArgs']]:
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: Optional[pulumi.Input['MongodbflexInstanceStorageArgs']]):
        pulumi.set(self, "storage", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version", value)


@pulumi.type_token("stackit:index/mongodbflexInstance:MongodbflexInstance")
class MongodbflexInstance(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 acls: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 backup_schedule: Optional[pulumi.Input[builtins.str]] = None,
                 flavor: Optional[pulumi.Input[Union['MongodbflexInstanceFlavorArgs', 'MongodbflexInstanceFlavorArgsDict']]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 options: Optional[pulumi.Input[Union['MongodbflexInstanceOptionsArgs', 'MongodbflexInstanceOptionsArgsDict']]] = None,
                 project_id: Optional[pulumi.Input[builtins.str]] = None,
                 replicas: Optional[pulumi.Input[builtins.int]] = None,
                 storage: Optional[pulumi.Input[Union['MongodbflexInstanceStorageArgs', 'MongodbflexInstanceStorageArgsDict']]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        MongoDB Flex instance resource schema. Must have a `region` specified in the provider configuration.

        ## Example Usage

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] acls: The Access Control List (ACL) for the MongoDB Flex instance.
        :param pulumi.Input[builtins.str] backup_schedule: The backup schedule. Should follow the cron scheduling system format (e.g. "0 0 * * *").
        :param pulumi.Input[builtins.str] name: Instance name.
        :param pulumi.Input[builtins.str] project_id: STACKIT project ID to which the instance is associated.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MongodbflexInstanceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        MongoDB Flex instance resource schema. Must have a `region` specified in the provider configuration.

        ## Example Usage

        :param str resource_name: The name of the resource.
        :param MongodbflexInstanceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MongodbflexInstanceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 acls: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 backup_schedule: Optional[pulumi.Input[builtins.str]] = None,
                 flavor: Optional[pulumi.Input[Union['MongodbflexInstanceFlavorArgs', 'MongodbflexInstanceFlavorArgsDict']]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 options: Optional[pulumi.Input[Union['MongodbflexInstanceOptionsArgs', 'MongodbflexInstanceOptionsArgsDict']]] = None,
                 project_id: Optional[pulumi.Input[builtins.str]] = None,
                 replicas: Optional[pulumi.Input[builtins.int]] = None,
                 storage: Optional[pulumi.Input[Union['MongodbflexInstanceStorageArgs', 'MongodbflexInstanceStorageArgsDict']]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MongodbflexInstanceArgs.__new__(MongodbflexInstanceArgs)

            if acls is None and not opts.urn:
                raise TypeError("Missing required property 'acls'")
            __props__.__dict__["acls"] = acls
            if backup_schedule is None and not opts.urn:
                raise TypeError("Missing required property 'backup_schedule'")
            __props__.__dict__["backup_schedule"] = backup_schedule
            if flavor is None and not opts.urn:
                raise TypeError("Missing required property 'flavor'")
            __props__.__dict__["flavor"] = flavor
            __props__.__dict__["name"] = name
            if options is None and not opts.urn:
                raise TypeError("Missing required property 'options'")
            __props__.__dict__["options"] = options
            if project_id is None and not opts.urn:
                raise TypeError("Missing required property 'project_id'")
            __props__.__dict__["project_id"] = project_id
            if replicas is None and not opts.urn:
                raise TypeError("Missing required property 'replicas'")
            __props__.__dict__["replicas"] = replicas
            if storage is None and not opts.urn:
                raise TypeError("Missing required property 'storage'")
            __props__.__dict__["storage"] = storage
            if version is None and not opts.urn:
                raise TypeError("Missing required property 'version'")
            __props__.__dict__["version"] = version
            __props__.__dict__["instance_id"] = None
        super(MongodbflexInstance, __self__).__init__(
            'stackit:index/mongodbflexInstance:MongodbflexInstance',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            acls: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            backup_schedule: Optional[pulumi.Input[builtins.str]] = None,
            flavor: Optional[pulumi.Input[Union['MongodbflexInstanceFlavorArgs', 'MongodbflexInstanceFlavorArgsDict']]] = None,
            instance_id: Optional[pulumi.Input[builtins.str]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            options: Optional[pulumi.Input[Union['MongodbflexInstanceOptionsArgs', 'MongodbflexInstanceOptionsArgsDict']]] = None,
            project_id: Optional[pulumi.Input[builtins.str]] = None,
            replicas: Optional[pulumi.Input[builtins.int]] = None,
            storage: Optional[pulumi.Input[Union['MongodbflexInstanceStorageArgs', 'MongodbflexInstanceStorageArgsDict']]] = None,
            version: Optional[pulumi.Input[builtins.str]] = None) -> 'MongodbflexInstance':
        """
        Get an existing MongodbflexInstance resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] acls: The Access Control List (ACL) for the MongoDB Flex instance.
        :param pulumi.Input[builtins.str] backup_schedule: The backup schedule. Should follow the cron scheduling system format (e.g. "0 0 * * *").
        :param pulumi.Input[builtins.str] instance_id: ID of the MongoDB Flex instance.
        :param pulumi.Input[builtins.str] name: Instance name.
        :param pulumi.Input[builtins.str] project_id: STACKIT project ID to which the instance is associated.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MongodbflexInstanceState.__new__(_MongodbflexInstanceState)

        __props__.__dict__["acls"] = acls
        __props__.__dict__["backup_schedule"] = backup_schedule
        __props__.__dict__["flavor"] = flavor
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["name"] = name
        __props__.__dict__["options"] = options
        __props__.__dict__["project_id"] = project_id
        __props__.__dict__["replicas"] = replicas
        __props__.__dict__["storage"] = storage
        __props__.__dict__["version"] = version
        return MongodbflexInstance(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def acls(self) -> pulumi.Output[Sequence[builtins.str]]:
        """
        The Access Control List (ACL) for the MongoDB Flex instance.
        """
        return pulumi.get(self, "acls")

    @property
    @pulumi.getter(name="backupSchedule")
    def backup_schedule(self) -> pulumi.Output[builtins.str]:
        """
        The backup schedule. Should follow the cron scheduling system format (e.g. "0 0 * * *").
        """
        return pulumi.get(self, "backup_schedule")

    @property
    @pulumi.getter
    def flavor(self) -> pulumi.Output['outputs.MongodbflexInstanceFlavor']:
        return pulumi.get(self, "flavor")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[builtins.str]:
        """
        ID of the MongoDB Flex instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        Instance name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def options(self) -> pulumi.Output['outputs.MongodbflexInstanceOptions']:
        return pulumi.get(self, "options")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Output[builtins.str]:
        """
        STACKIT project ID to which the instance is associated.
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter
    def replicas(self) -> pulumi.Output[builtins.int]:
        return pulumi.get(self, "replicas")

    @property
    @pulumi.getter
    def storage(self) -> pulumi.Output['outputs.MongodbflexInstanceStorage']:
        return pulumi.get(self, "storage")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "version")

