# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['ObjectstorageBucketArgs', 'ObjectstorageBucket']

@pulumi.input_type
class ObjectstorageBucketArgs:
    def __init__(__self__, *,
                 project_id: pulumi.Input[builtins.str],
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a ObjectstorageBucket resource.
        :param pulumi.Input[builtins.str] project_id: STACKIT Project ID to which the bucket is associated.
        :param pulumi.Input[builtins.str] name: The bucket name. It must be DNS conform.
        :param pulumi.Input[builtins.str] region: The resource region. If not defined, the provider region is used.
        """
        pulumi.set(__self__, "project_id", project_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if region is not None:
            pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Input[builtins.str]:
        """
        STACKIT Project ID to which the bucket is associated.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The bucket name. It must be DNS conform.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The resource region. If not defined, the provider region is used.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)


@pulumi.input_type
class _ObjectstorageBucketState:
    def __init__(__self__, *,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 project_id: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 url_path_style: Optional[pulumi.Input[builtins.str]] = None,
                 url_virtual_hosted_style: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering ObjectstorageBucket resources.
        :param pulumi.Input[builtins.str] name: The bucket name. It must be DNS conform.
        :param pulumi.Input[builtins.str] project_id: STACKIT Project ID to which the bucket is associated.
        :param pulumi.Input[builtins.str] region: The resource region. If not defined, the provider region is used.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if url_path_style is not None:
            pulumi.set(__self__, "url_path_style", url_path_style)
        if url_virtual_hosted_style is not None:
            pulumi.set(__self__, "url_virtual_hosted_style", url_virtual_hosted_style)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The bucket name. It must be DNS conform.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        STACKIT Project ID to which the bucket is associated.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The resource region. If not defined, the provider region is used.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="urlPathStyle")
    def url_path_style(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "url_path_style")

    @url_path_style.setter
    def url_path_style(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "url_path_style", value)

    @property
    @pulumi.getter(name="urlVirtualHostedStyle")
    def url_virtual_hosted_style(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "url_virtual_hosted_style")

    @url_virtual_hosted_style.setter
    def url_virtual_hosted_style(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "url_virtual_hosted_style", value)


@pulumi.type_token("stackit:index/objectstorageBucket:ObjectstorageBucket")
class ObjectstorageBucket(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 project_id: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        ObjectStorage bucket resource schema. Must have a `region` specified in the provider configuration. If you are creating `credentialsgroup` and `bucket` resources simultaneously, please include the `depends_on` field so that they are created sequentially. This prevents errors from concurrent calls to the service enablement that is done in the background.

        ## Example Usage

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] name: The bucket name. It must be DNS conform.
        :param pulumi.Input[builtins.str] project_id: STACKIT Project ID to which the bucket is associated.
        :param pulumi.Input[builtins.str] region: The resource region. If not defined, the provider region is used.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ObjectstorageBucketArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ObjectStorage bucket resource schema. Must have a `region` specified in the provider configuration. If you are creating `credentialsgroup` and `bucket` resources simultaneously, please include the `depends_on` field so that they are created sequentially. This prevents errors from concurrent calls to the service enablement that is done in the background.

        ## Example Usage

        :param str resource_name: The name of the resource.
        :param ObjectstorageBucketArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ObjectstorageBucketArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 project_id: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ObjectstorageBucketArgs.__new__(ObjectstorageBucketArgs)

            __props__.__dict__["name"] = name
            if project_id is None and not opts.urn:
                raise TypeError("Missing required property 'project_id'")
            __props__.__dict__["project_id"] = project_id
            __props__.__dict__["region"] = region
            __props__.__dict__["url_path_style"] = None
            __props__.__dict__["url_virtual_hosted_style"] = None
        super(ObjectstorageBucket, __self__).__init__(
            'stackit:index/objectstorageBucket:ObjectstorageBucket',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            project_id: Optional[pulumi.Input[builtins.str]] = None,
            region: Optional[pulumi.Input[builtins.str]] = None,
            url_path_style: Optional[pulumi.Input[builtins.str]] = None,
            url_virtual_hosted_style: Optional[pulumi.Input[builtins.str]] = None) -> 'ObjectstorageBucket':
        """
        Get an existing ObjectstorageBucket resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] name: The bucket name. It must be DNS conform.
        :param pulumi.Input[builtins.str] project_id: STACKIT Project ID to which the bucket is associated.
        :param pulumi.Input[builtins.str] region: The resource region. If not defined, the provider region is used.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ObjectstorageBucketState.__new__(_ObjectstorageBucketState)

        __props__.__dict__["name"] = name
        __props__.__dict__["project_id"] = project_id
        __props__.__dict__["region"] = region
        __props__.__dict__["url_path_style"] = url_path_style
        __props__.__dict__["url_virtual_hosted_style"] = url_virtual_hosted_style
        return ObjectstorageBucket(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The bucket name. It must be DNS conform.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Output[builtins.str]:
        """
        STACKIT Project ID to which the bucket is associated.
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[builtins.str]:
        """
        The resource region. If not defined, the provider region is used.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="urlPathStyle")
    def url_path_style(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "url_path_style")

    @property
    @pulumi.getter(name="urlVirtualHostedStyle")
    def url_virtual_hosted_style(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "url_virtual_hosted_style")

