# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['RabbitmqCredentialArgs', 'RabbitmqCredential']

@pulumi.input_type
class RabbitmqCredentialArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[builtins.str],
                 project_id: pulumi.Input[builtins.str]):
        """
        The set of arguments for constructing a RabbitmqCredential resource.
        :param pulumi.Input[builtins.str] instance_id: ID of the RabbitMQ instance.
        :param pulumi.Input[builtins.str] project_id: STACKIT Project ID to which the instance is associated.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "project_id", project_id)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[builtins.str]:
        """
        ID of the RabbitMQ instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Input[builtins.str]:
        """
        STACKIT Project ID to which the instance is associated.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "project_id", value)


@pulumi.input_type
class _RabbitmqCredentialState:
    def __init__(__self__, *,
                 credential_id: Optional[pulumi.Input[builtins.str]] = None,
                 host: Optional[pulumi.Input[builtins.str]] = None,
                 hosts: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 http_api_uri: Optional[pulumi.Input[builtins.str]] = None,
                 http_api_uris: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 management: Optional[pulumi.Input[builtins.str]] = None,
                 password: Optional[pulumi.Input[builtins.str]] = None,
                 port: Optional[pulumi.Input[builtins.int]] = None,
                 project_id: Optional[pulumi.Input[builtins.str]] = None,
                 uri: Optional[pulumi.Input[builtins.str]] = None,
                 uris: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 username: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering RabbitmqCredential resources.
        :param pulumi.Input[builtins.str] credential_id: The credential's ID.
        :param pulumi.Input[builtins.str] instance_id: ID of the RabbitMQ instance.
        :param pulumi.Input[builtins.str] project_id: STACKIT Project ID to which the instance is associated.
        """
        if credential_id is not None:
            pulumi.set(__self__, "credential_id", credential_id)
        if host is not None:
            pulumi.set(__self__, "host", host)
        if hosts is not None:
            pulumi.set(__self__, "hosts", hosts)
        if http_api_uri is not None:
            pulumi.set(__self__, "http_api_uri", http_api_uri)
        if http_api_uris is not None:
            pulumi.set(__self__, "http_api_uris", http_api_uris)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if management is not None:
            pulumi.set(__self__, "management", management)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)
        if uri is not None:
            pulumi.set(__self__, "uri", uri)
        if uris is not None:
            pulumi.set(__self__, "uris", uris)
        if username is not None:
            pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter(name="credentialId")
    def credential_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The credential's ID.
        """
        return pulumi.get(self, "credential_id")

    @credential_id.setter
    def credential_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "credential_id", value)

    @property
    @pulumi.getter
    def host(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "host")

    @host.setter
    def host(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "host", value)

    @property
    @pulumi.getter
    def hosts(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "hosts")

    @hosts.setter
    def hosts(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "hosts", value)

    @property
    @pulumi.getter(name="httpApiUri")
    def http_api_uri(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "http_api_uri")

    @http_api_uri.setter
    def http_api_uri(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "http_api_uri", value)

    @property
    @pulumi.getter(name="httpApiUris")
    def http_api_uris(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "http_api_uris")

    @http_api_uris.setter
    def http_api_uris(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "http_api_uris", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        ID of the RabbitMQ instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def management(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "management")

    @management.setter
    def management(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "management", value)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter
    def port(self) -> Optional[pulumi.Input[builtins.int]]:
        return pulumi.get(self, "port")

    @port.setter
    def port(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "port", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        STACKIT Project ID to which the instance is associated.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter
    def uri(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "uri")

    @uri.setter
    def uri(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "uri", value)

    @property
    @pulumi.getter
    def uris(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "uris")

    @uris.setter
    def uris(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "uris", value)

    @property
    @pulumi.getter
    def username(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "username", value)


@pulumi.type_token("stackit:index/rabbitmqCredential:RabbitmqCredential")
class RabbitmqCredential(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 project_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        RabbitMQ credential resource schema. Must have a `region` specified in the provider configuration.

        ## Example Usage

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] instance_id: ID of the RabbitMQ instance.
        :param pulumi.Input[builtins.str] project_id: STACKIT Project ID to which the instance is associated.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RabbitmqCredentialArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        RabbitMQ credential resource schema. Must have a `region` specified in the provider configuration.

        ## Example Usage

        :param str resource_name: The name of the resource.
        :param RabbitmqCredentialArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RabbitmqCredentialArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[builtins.str]] = None,
                 project_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RabbitmqCredentialArgs.__new__(RabbitmqCredentialArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if project_id is None and not opts.urn:
                raise TypeError("Missing required property 'project_id'")
            __props__.__dict__["project_id"] = project_id
            __props__.__dict__["credential_id"] = None
            __props__.__dict__["host"] = None
            __props__.__dict__["hosts"] = None
            __props__.__dict__["http_api_uri"] = None
            __props__.__dict__["http_api_uris"] = None
            __props__.__dict__["management"] = None
            __props__.__dict__["password"] = None
            __props__.__dict__["port"] = None
            __props__.__dict__["uri"] = None
            __props__.__dict__["uris"] = None
            __props__.__dict__["username"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["password", "uri"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(RabbitmqCredential, __self__).__init__(
            'stackit:index/rabbitmqCredential:RabbitmqCredential',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            credential_id: Optional[pulumi.Input[builtins.str]] = None,
            host: Optional[pulumi.Input[builtins.str]] = None,
            hosts: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            http_api_uri: Optional[pulumi.Input[builtins.str]] = None,
            http_api_uris: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            instance_id: Optional[pulumi.Input[builtins.str]] = None,
            management: Optional[pulumi.Input[builtins.str]] = None,
            password: Optional[pulumi.Input[builtins.str]] = None,
            port: Optional[pulumi.Input[builtins.int]] = None,
            project_id: Optional[pulumi.Input[builtins.str]] = None,
            uri: Optional[pulumi.Input[builtins.str]] = None,
            uris: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            username: Optional[pulumi.Input[builtins.str]] = None) -> 'RabbitmqCredential':
        """
        Get an existing RabbitmqCredential resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] credential_id: The credential's ID.
        :param pulumi.Input[builtins.str] instance_id: ID of the RabbitMQ instance.
        :param pulumi.Input[builtins.str] project_id: STACKIT Project ID to which the instance is associated.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RabbitmqCredentialState.__new__(_RabbitmqCredentialState)

        __props__.__dict__["credential_id"] = credential_id
        __props__.__dict__["host"] = host
        __props__.__dict__["hosts"] = hosts
        __props__.__dict__["http_api_uri"] = http_api_uri
        __props__.__dict__["http_api_uris"] = http_api_uris
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["management"] = management
        __props__.__dict__["password"] = password
        __props__.__dict__["port"] = port
        __props__.__dict__["project_id"] = project_id
        __props__.__dict__["uri"] = uri
        __props__.__dict__["uris"] = uris
        __props__.__dict__["username"] = username
        return RabbitmqCredential(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="credentialId")
    def credential_id(self) -> pulumi.Output[builtins.str]:
        """
        The credential's ID.
        """
        return pulumi.get(self, "credential_id")

    @property
    @pulumi.getter
    def host(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "host")

    @property
    @pulumi.getter
    def hosts(self) -> pulumi.Output[Sequence[builtins.str]]:
        return pulumi.get(self, "hosts")

    @property
    @pulumi.getter(name="httpApiUri")
    def http_api_uri(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "http_api_uri")

    @property
    @pulumi.getter(name="httpApiUris")
    def http_api_uris(self) -> pulumi.Output[Sequence[builtins.str]]:
        return pulumi.get(self, "http_api_uris")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[builtins.str]:
        """
        ID of the RabbitMQ instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def management(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "management")

    @property
    @pulumi.getter
    def password(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "password")

    @property
    @pulumi.getter
    def port(self) -> pulumi.Output[builtins.int]:
        return pulumi.get(self, "port")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Output[builtins.str]:
        """
        STACKIT Project ID to which the instance is associated.
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter
    def uri(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "uri")

    @property
    @pulumi.getter
    def uris(self) -> pulumi.Output[Sequence[builtins.str]]:
        return pulumi.get(self, "uris")

    @property
    @pulumi.getter
    def username(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "username")

