# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['ServerUpdateScheduleArgs', 'ServerUpdateSchedule']

@pulumi.input_type
class ServerUpdateScheduleArgs:
    def __init__(__self__, *,
                 enabled: pulumi.Input[builtins.bool],
                 maintenance_window: pulumi.Input[builtins.int],
                 project_id: pulumi.Input[builtins.str],
                 rrule: pulumi.Input[builtins.str],
                 server_id: pulumi.Input[builtins.str],
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a ServerUpdateSchedule resource.
        :param pulumi.Input[builtins.bool] enabled: Is the update schedule enabled or disabled.
        :param pulumi.Input[builtins.int] maintenance_window: Maintenance window [1..24].
        :param pulumi.Input[builtins.str] project_id: STACKIT Project ID to which the server is associated.
        :param pulumi.Input[builtins.str] rrule: Update schedule described in `rrule` (recurrence rule) format.
        :param pulumi.Input[builtins.str] server_id: Server ID for the update schedule.
        :param pulumi.Input[builtins.str] name: The schedule name.
        :param pulumi.Input[builtins.str] region: The resource region. If not defined, the provider region is used.
        """
        pulumi.set(__self__, "enabled", enabled)
        pulumi.set(__self__, "maintenance_window", maintenance_window)
        pulumi.set(__self__, "project_id", project_id)
        pulumi.set(__self__, "rrule", rrule)
        pulumi.set(__self__, "server_id", server_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if region is not None:
            pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Input[builtins.bool]:
        """
        Is the update schedule enabled or disabled.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: pulumi.Input[builtins.bool]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="maintenanceWindow")
    def maintenance_window(self) -> pulumi.Input[builtins.int]:
        """
        Maintenance window [1..24].
        """
        return pulumi.get(self, "maintenance_window")

    @maintenance_window.setter
    def maintenance_window(self, value: pulumi.Input[builtins.int]):
        pulumi.set(self, "maintenance_window", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Input[builtins.str]:
        """
        STACKIT Project ID to which the server is associated.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter
    def rrule(self) -> pulumi.Input[builtins.str]:
        """
        Update schedule described in `rrule` (recurrence rule) format.
        """
        return pulumi.get(self, "rrule")

    @rrule.setter
    def rrule(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "rrule", value)

    @property
    @pulumi.getter(name="serverId")
    def server_id(self) -> pulumi.Input[builtins.str]:
        """
        Server ID for the update schedule.
        """
        return pulumi.get(self, "server_id")

    @server_id.setter
    def server_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "server_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The schedule name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The resource region. If not defined, the provider region is used.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)


@pulumi.input_type
class _ServerUpdateScheduleState:
    def __init__(__self__, *,
                 enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 maintenance_window: Optional[pulumi.Input[builtins.int]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 project_id: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 rrule: Optional[pulumi.Input[builtins.str]] = None,
                 server_id: Optional[pulumi.Input[builtins.str]] = None,
                 update_schedule_id: Optional[pulumi.Input[builtins.int]] = None):
        """
        Input properties used for looking up and filtering ServerUpdateSchedule resources.
        :param pulumi.Input[builtins.bool] enabled: Is the update schedule enabled or disabled.
        :param pulumi.Input[builtins.int] maintenance_window: Maintenance window [1..24].
        :param pulumi.Input[builtins.str] name: The schedule name.
        :param pulumi.Input[builtins.str] project_id: STACKIT Project ID to which the server is associated.
        :param pulumi.Input[builtins.str] region: The resource region. If not defined, the provider region is used.
        :param pulumi.Input[builtins.str] rrule: Update schedule described in `rrule` (recurrence rule) format.
        :param pulumi.Input[builtins.str] server_id: Server ID for the update schedule.
        :param pulumi.Input[builtins.int] update_schedule_id: Update schedule ID.
        """
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if maintenance_window is not None:
            pulumi.set(__self__, "maintenance_window", maintenance_window)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if rrule is not None:
            pulumi.set(__self__, "rrule", rrule)
        if server_id is not None:
            pulumi.set(__self__, "server_id", server_id)
        if update_schedule_id is not None:
            pulumi.set(__self__, "update_schedule_id", update_schedule_id)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Is the update schedule enabled or disabled.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="maintenanceWindow")
    def maintenance_window(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Maintenance window [1..24].
        """
        return pulumi.get(self, "maintenance_window")

    @maintenance_window.setter
    def maintenance_window(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "maintenance_window", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The schedule name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        STACKIT Project ID to which the server is associated.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The resource region. If not defined, the provider region is used.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def rrule(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Update schedule described in `rrule` (recurrence rule) format.
        """
        return pulumi.get(self, "rrule")

    @rrule.setter
    def rrule(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "rrule", value)

    @property
    @pulumi.getter(name="serverId")
    def server_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Server ID for the update schedule.
        """
        return pulumi.get(self, "server_id")

    @server_id.setter
    def server_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "server_id", value)

    @property
    @pulumi.getter(name="updateScheduleId")
    def update_schedule_id(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Update schedule ID.
        """
        return pulumi.get(self, "update_schedule_id")

    @update_schedule_id.setter
    def update_schedule_id(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "update_schedule_id", value)


@pulumi.type_token("stackit:index/serverUpdateSchedule:ServerUpdateSchedule")
class ServerUpdateSchedule(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 maintenance_window: Optional[pulumi.Input[builtins.int]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 project_id: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 rrule: Optional[pulumi.Input[builtins.str]] = None,
                 server_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Server update schedule resource schema. Must have a `region` specified in the provider configuration.

        > This resource is in beta and may be subject to breaking changes in the future. Use with caution. See our guide for how to opt-in to use beta resources.

        ## Example Usage

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.bool] enabled: Is the update schedule enabled or disabled.
        :param pulumi.Input[builtins.int] maintenance_window: Maintenance window [1..24].
        :param pulumi.Input[builtins.str] name: The schedule name.
        :param pulumi.Input[builtins.str] project_id: STACKIT Project ID to which the server is associated.
        :param pulumi.Input[builtins.str] region: The resource region. If not defined, the provider region is used.
        :param pulumi.Input[builtins.str] rrule: Update schedule described in `rrule` (recurrence rule) format.
        :param pulumi.Input[builtins.str] server_id: Server ID for the update schedule.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ServerUpdateScheduleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Server update schedule resource schema. Must have a `region` specified in the provider configuration.

        > This resource is in beta and may be subject to breaking changes in the future. Use with caution. See our guide for how to opt-in to use beta resources.

        ## Example Usage

        :param str resource_name: The name of the resource.
        :param ServerUpdateScheduleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ServerUpdateScheduleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 maintenance_window: Optional[pulumi.Input[builtins.int]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 project_id: Optional[pulumi.Input[builtins.str]] = None,
                 region: Optional[pulumi.Input[builtins.str]] = None,
                 rrule: Optional[pulumi.Input[builtins.str]] = None,
                 server_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ServerUpdateScheduleArgs.__new__(ServerUpdateScheduleArgs)

            if enabled is None and not opts.urn:
                raise TypeError("Missing required property 'enabled'")
            __props__.__dict__["enabled"] = enabled
            if maintenance_window is None and not opts.urn:
                raise TypeError("Missing required property 'maintenance_window'")
            __props__.__dict__["maintenance_window"] = maintenance_window
            __props__.__dict__["name"] = name
            if project_id is None and not opts.urn:
                raise TypeError("Missing required property 'project_id'")
            __props__.__dict__["project_id"] = project_id
            __props__.__dict__["region"] = region
            if rrule is None and not opts.urn:
                raise TypeError("Missing required property 'rrule'")
            __props__.__dict__["rrule"] = rrule
            if server_id is None and not opts.urn:
                raise TypeError("Missing required property 'server_id'")
            __props__.__dict__["server_id"] = server_id
            __props__.__dict__["update_schedule_id"] = None
        super(ServerUpdateSchedule, __self__).__init__(
            'stackit:index/serverUpdateSchedule:ServerUpdateSchedule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            enabled: Optional[pulumi.Input[builtins.bool]] = None,
            maintenance_window: Optional[pulumi.Input[builtins.int]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            project_id: Optional[pulumi.Input[builtins.str]] = None,
            region: Optional[pulumi.Input[builtins.str]] = None,
            rrule: Optional[pulumi.Input[builtins.str]] = None,
            server_id: Optional[pulumi.Input[builtins.str]] = None,
            update_schedule_id: Optional[pulumi.Input[builtins.int]] = None) -> 'ServerUpdateSchedule':
        """
        Get an existing ServerUpdateSchedule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.bool] enabled: Is the update schedule enabled or disabled.
        :param pulumi.Input[builtins.int] maintenance_window: Maintenance window [1..24].
        :param pulumi.Input[builtins.str] name: The schedule name.
        :param pulumi.Input[builtins.str] project_id: STACKIT Project ID to which the server is associated.
        :param pulumi.Input[builtins.str] region: The resource region. If not defined, the provider region is used.
        :param pulumi.Input[builtins.str] rrule: Update schedule described in `rrule` (recurrence rule) format.
        :param pulumi.Input[builtins.str] server_id: Server ID for the update schedule.
        :param pulumi.Input[builtins.int] update_schedule_id: Update schedule ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ServerUpdateScheduleState.__new__(_ServerUpdateScheduleState)

        __props__.__dict__["enabled"] = enabled
        __props__.__dict__["maintenance_window"] = maintenance_window
        __props__.__dict__["name"] = name
        __props__.__dict__["project_id"] = project_id
        __props__.__dict__["region"] = region
        __props__.__dict__["rrule"] = rrule
        __props__.__dict__["server_id"] = server_id
        __props__.__dict__["update_schedule_id"] = update_schedule_id
        return ServerUpdateSchedule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Output[builtins.bool]:
        """
        Is the update schedule enabled or disabled.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="maintenanceWindow")
    def maintenance_window(self) -> pulumi.Output[builtins.int]:
        """
        Maintenance window [1..24].
        """
        return pulumi.get(self, "maintenance_window")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The schedule name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Output[builtins.str]:
        """
        STACKIT Project ID to which the server is associated.
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[builtins.str]:
        """
        The resource region. If not defined, the provider region is used.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def rrule(self) -> pulumi.Output[builtins.str]:
        """
        Update schedule described in `rrule` (recurrence rule) format.
        """
        return pulumi.get(self, "rrule")

    @property
    @pulumi.getter(name="serverId")
    def server_id(self) -> pulumi.Output[builtins.str]:
        """
        Server ID for the update schedule.
        """
        return pulumi.get(self, "server_id")

    @property
    @pulumi.getter(name="updateScheduleId")
    def update_schedule_id(self) -> pulumi.Output[builtins.int]:
        """
        Update schedule ID.
        """
        return pulumi.get(self, "update_schedule_id")

